#include "list.h"
#include "ilist.h"

int main () {
    int elm = -1;
    list<int> lst;
    while (elm != 0) {
        cin >> elm;
        if (elm != 0)
            lst.cons(elm);
    }

    cout << "List iterators.\n";
    for (list<int>::iterator i = lst.begin(); i != lst.end(); ++i)
        cout << "Iterating through element with value " << *i << "\n";
    lst.rmth(1);
    lst.rmth(10);
    cout << "lst = " << lst << "\n";

    cout << "Using copy constructor from list to ilist.\n";
    ilist<int> il(lst);
    cout << "indexed lists: il[3] = " << il[3] << "\n";
    cout << "Using assignment operator from list to ilist.\n";
    ilist<int> il1;
    il1 = lst;
    cout << "indexed lists: il1[3] = " << il1[3] << "\n";

    cout << "il is now: " << il << "\n";
    cout << "We do il[3] = 7...\n";
    il[3] = 7;
    cout << "... and il is now: " << il << "\n";

    list<int>* plist = new list<int>;

    cout << "We do list clone(lst);\n"; 
    cout << "      lst.cdr(); lst.cdr();\n";
    list<int> clone(lst);
    lst.cdr();
    lst.cdr();
    cout << "lst = " << lst << "\n";
    cout << "clone = " << clone << "\n";

    cout << "We now call delete plist\n";
    delete(plist);

    cout << "We do clone1 = lst;\n"; 
    cout << "      lst.cdr(); lst.cdr();\n";
    list<int> clone1;
    clone1 = lst;
    lst.cdr();
    lst.cdr();
    cout << "lst = " << lst << "\n";
    cout << "clone1 = " << clone1 << "\n";
}
