#ifndef __ILIST_H
#define __ILIST_H

#include "list.h"

/*** Declarations: ***/

template <class content_t>
class ilist: public list<content_t> {
 public:
    ilist(void);
    ilist(const list<content_t>&);
    content_t& operator[](int) const; 
};

/*** Definitions: ***/

template <class content_t>
ilist<content_t>::ilist(void)
    : list<content_t>() {
    /* empty */
}

template <class content_t>
ilist<content_t>::ilist(const list<content_t>& l) 
    : list<content_t>(l) {
    /* empty */
}

template <class content_t>
content_t& ilist<content_t>::operator[](int which) const {
    cons_cell<content_t>* place = list<content_t>::content;
    for (int i = 0; i < which; i++)
        place = place -> cdr;
    return place -> car;
}

#endif /* __ILIST_H */
